classdef DefaultParameters
    properties(Constant)        
        filter_params = struct('filter_mode', 'EU', ...
                                'high_freq', 0.5, ...
                                'high_order', [], ... % Will use default
                                'low_freq', -1, ... % Will desactivate the operation
                                'low_order', [], ... % Will use default
                                'run_message', 'Perform Filtering...');

        channel_rejection_params = struct('kurt_thresh', 3,...
                                'prob_thresh', 4,...
                                'spec_thresh', 4,...
                                'run_message', 'Finding bad channels...');
        
        interpolation_params = struct('method', 'spherical');
        
        pca_params = struct('lambda', [], ...  % Will use default
                            'tol', 1e-7, ...
                            'maxIter', 1000, ...
                            'pca_url', 'http://perception.csl.illinois.edu/matrix-rank/Files/inexact_alm_rpca.zip', ...
                            'run_message', 'Performing PCA  (this may take a while...)');
                        
        ica_params = struct('chanloc_map', containers.Map, ...
                            'bool', 0, ...
                            'run_message', 'Performing ICA  (this may take a while...)')
                    
        eog_regression_params = struct('perform_eog_regression', 1, ...
                            'eog_chans', '', ...
                            'run_message', 'Perform EOG Regression...');
                        
        channel_reduction_params = struct('perform_reduce_channels', 1, ...
                            'tobe_excluded_chans', '');
                        
        eeg_system = struct('name', 'EGI',...
                            'EGI_name', 'EGI',...
                            'Others_name', 'Others', ...
                            'loc_file', '', ...
                            'file_loc_type', '');
                        
        general_params = struct('original_file', '', ...
                            'reduced_name', 'reduced');                
                    
    end
end



%       eeg_system
%       perform_reduce_channels